package cn.iocoder.yudao.module.mes.service.errorrecord;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;

import javax.annotation.Resource;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.errorrecord.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.errorrecord.ErrorRecordDO;
import cn.iocoder.yudao.module.mes.dal.mysql.errorrecord.ErrorRecordMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import javax.annotation.Resource;
import org.springframework.context.annotation.Import;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link ErrorRecordServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(ErrorRecordServiceImpl.class)
public class ErrorRecordServiceImplTest extends BaseDbUnitTest {

    @Resource
    private ErrorRecordServiceImpl errorRecordService;

    @Resource
    private ErrorRecordMapper errorRecordMapper;

    @Test
    public void testCreateErrorRecord_success() {
        // 准备参数
        ErrorRecordSaveReqVO createReqVO = randomPojo(ErrorRecordSaveReqVO.class).setId(null);

        // 调用
        Long errorRecordId = errorRecordService.createErrorRecord(createReqVO);
        // 断言
        assertNotNull(errorRecordId);
        // 校验记录的属性是否正确
        ErrorRecordDO errorRecord = errorRecordMapper.selectById(errorRecordId);
        assertPojoEquals(createReqVO, errorRecord, "id");
    }

    @Test
    public void testUpdateErrorRecord_success() {
        // mock 数据
        ErrorRecordDO dbErrorRecord = randomPojo(ErrorRecordDO.class);
        errorRecordMapper.insert(dbErrorRecord);// @Sql: 先插入出一条存在的数据
        // 准备参数
        ErrorRecordSaveReqVO updateReqVO = randomPojo(ErrorRecordSaveReqVO.class, o -> {
            o.setId(dbErrorRecord.getId()); // 设置更新的 ID
        });

        // 调用
        errorRecordService.updateErrorRecord(updateReqVO);
        // 校验是否更新正确
        ErrorRecordDO errorRecord = errorRecordMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, errorRecord);
    }

    @Test
    public void testUpdateErrorRecord_notExists() {
        // 准备参数
        ErrorRecordSaveReqVO updateReqVO = randomPojo(ErrorRecordSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> errorRecordService.updateErrorRecord(updateReqVO), ERROR_RECORD_NOT_EXISTS);
    }

    @Test
    public void testDeleteErrorRecord_success() {
        // mock 数据
        ErrorRecordDO dbErrorRecord = randomPojo(ErrorRecordDO.class);
        errorRecordMapper.insert(dbErrorRecord);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbErrorRecord.getId();

        // 调用
        errorRecordService.deleteErrorRecord(id);
       // 校验数据不存在了
       assertNull(errorRecordMapper.selectById(id));
    }

    @Test
    public void testDeleteErrorRecord_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> errorRecordService.deleteErrorRecord(id), ERROR_RECORD_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetErrorRecordPage() {
       // mock 数据
       ErrorRecordDO dbErrorRecord = randomPojo(ErrorRecordDO.class, o -> { // 等会查询到
           o.setTitle(null);
           o.setLocation(null);
           o.setException(null);
           o.setPreData(null);
           o.setPostData(null);
           o.setCreateTime(null);
       });
       errorRecordMapper.insert(dbErrorRecord);
       // 测试 title 不匹配
       errorRecordMapper.insert(cloneIgnoreId(dbErrorRecord, o -> o.setTitle(null)));
       // 测试 location 不匹配
       errorRecordMapper.insert(cloneIgnoreId(dbErrorRecord, o -> o.setLocation(null)));
       // 测试 exception 不匹配
       errorRecordMapper.insert(cloneIgnoreId(dbErrorRecord, o -> o.setException(null)));
       // 测试 preData 不匹配
       errorRecordMapper.insert(cloneIgnoreId(dbErrorRecord, o -> o.setPreData(null)));
       // 测试 postData 不匹配
       errorRecordMapper.insert(cloneIgnoreId(dbErrorRecord, o -> o.setPostData(null)));
       // 测试 createTime 不匹配
       errorRecordMapper.insert(cloneIgnoreId(dbErrorRecord, o -> o.setCreateTime(null)));
       // 准备参数
       ErrorRecordPageReqVO reqVO = new ErrorRecordPageReqVO();
       reqVO.setTitle(null);
       reqVO.setLocation(null);
       reqVO.setException(null);
       reqVO.setPreData(null);
       reqVO.setPostData(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<ErrorRecordDO> pageResult = errorRecordService.getErrorRecordPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbErrorRecord, pageResult.getList().get(0));
    }

}